<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import AdminProductModule from "~/store/adminCollection";
import { api, regexDomain } from "~/common/constaint";
import _, { cloneDeep } from "lodash";
import { parseTxtText } from "~/common/verifyEmailTxt";
import {
  IActionDomain,
  IDomainInfo,
  IResponseDomain,
  ISSLInfo,
} from "~/interfaces/domain";
var momentz = require("moment-timezone");
var moment = require("moment");

const parseGenerateDomain = (): IResponseDomain => ({
  createdAt: "",
  domain: "",
  enabled: false,
  id: "",
  supportEmail: "",
  updatedAt: "",
  _id: "",
  isVerifiedMail: false,
});

@Component({})
export default class AdminDomainComponent extends Vue {
  listDomain = [];
  dialogCreateDomain = false;
  dialogCreateSupportEmail = false;
  dialogActiveDomain = false;
  dialogEditEmail = false;
  dialogResendEmail = false;
  dialogVerifyEmail = false;
  dialogEditDomain = false;
  dialogRemoveDomain = false;
  dialogEnableSsl = false;

  isErrorSsl = false;

  config = {
    page: 1,
    limit: 25,
    search: "",
  };
  page = 1;
  totalPage: number = 1;
  loading = false;
  loadingTable = false;
  loadingInfo = false;

  domainName = "";
  supportEmail = "";
  token = "";

  domain: IResponseDomain = parseGenerateDomain();
  domainId: string = "";

  domainInfo: IDomainInfo[] = [];
  sslInfo: ISSLInfo[] = [];

  mounted() {
    this.onGetList();
  }

  dataVerify = {};

  async onGetList() {
    try {
      this.loadingTable = true;
      const res = await this.$api.domain.list(this.config);
      if (res?.data?.data) {
        const { total } = res.data;
        this.totalPage = Math.ceil(total / this.config.limit);
        this.listDomain = res.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  async onCreateDomain() {
    try {
      if (!this.domainName) {
        return this.$pushNotification.error("Please enter domain");
      }
      if (!regexDomain.test(this.domainName)) {
        return this.$pushNotification.error("Domain not invalid");
      }
      this.loading = true;
      const body = {
        domain: this.domainName,
        enabled: false,
        supportEmail: this.supportEmail || "",
      };
      await this.$api.domain.create(body);
      this.$pushNotification.success("Create domain successfully");
      this.domainName = "";
      this.dialogCreateDomain = false;
      this.onGetList();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async openDialog(domain: IResponseDomain, type: string) {
    if (domain._id) {
      this.domain = cloneDeep(domain);
      switch (type) {
        case IActionDomain.ADD_SUPPORTEMAIL:
          this.dialogCreateSupportEmail = true;
          break;
        case IActionDomain.EDIT_EMAIL:
          this.dialogEditEmail = true;
          break;
        case IActionDomain.EDIT_DOMAIN:
          this.dialogEditDomain = true;
          break;
        case IActionDomain.ACTIVE_DOMAIN:
          this.onGetPointDomainInfo();
          this.dialogActiveDomain = true;
          break;
        case IActionDomain.VERIFY_EMAIL:
          this.dialogVerifyEmail = true;
          break;
        case IActionDomain.RESEND_EMAIL:
          this.dialogResendEmail = true;
          break;
        case IActionDomain.DELETE_DOMAIN:
          this.dialogRemoveDomain = true;
          break;
        case IActionDomain.ENABLE_SSL:
          this.onGetSslInfo();
          this.dialogEnableSsl = true;
          break;
        default:
          this.dialogCreateSupportEmail = true;
      }
    }
  }

  async onUpdateDomain() {
    try {
      if (!this.supportEmail) {
        if (!this.domain.domain) {
          return this.$pushNotification.error("Please enter domain");
        }
        if (!regexDomain.test(this.domain.domain)) {
          return this.$pushNotification.error("Domain not invalid");
        }
      }
      this.loading = true;
      const body = {
        domainId: this.domain._id,
        domain: this.domain.domain,
        enabled: this.domain.enabled,
        isVerifiedMail: this.domain.isVerifiedMail,
        supportEmail: this.supportEmail || this.domain.supportEmail,
      };
      await this.$api.domain.update(body);
      if (this.supportEmail) {
        this.$pushNotification.success("Add support email successfully");
      } else {
        this.$pushNotification.success("Update domain successfully");
      }
      this.dialogEditDomain = false;
      this.dialogCreateSupportEmail = false;
      this.supportEmail = "";
      this.onGetList();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async onAddSupportEmail() {
    try {
      if (!this.supportEmail && !this.domain.supportEmail) {
        return this.$pushNotification.error("Please enter support email");
      }
      this.loading = true;
      const body = {
        domainId: this.domain._id,
        supportEmail: this.supportEmail || this.domain.supportEmail,
      };
      await this.$api.domain.addSupportEmail(body);
      this.$pushNotification.success("Add support email successfully");
      this.dialogCreateSupportEmail = false;
      this.dialogEditEmail = false;
      this.supportEmail = "";
      this.loading = true;
      this.onGetList();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async onVerifyEmail() {
    try {
      if (!this.domain._id) {
        return this.$pushNotification.error("Not found DomainId");
      }
      this.loading = true;
      await this.$api.domain.verifyEmail(this.domain._id);

      this.$pushNotification.success("Verify email successfully");
      this.dialogVerifyEmail = false;
      this.onGetList();
    } catch (error: any) {
      if (error?.response?.data?.data) {
        this.dataVerify = error.response.data.data;
      }
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async onGetPointDomainInfo() {
    try {
      if (!this.domain._id) {
        return this.$pushNotification.error("Not found DomainId");
      }
      this.loadingInfo = true;
      const response = await this.$api.domain.getPointDomainInfo(
        this.domain._id
      );
      if (response?.data?.dns.length) {
        this.domainInfo = response.data.dns;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingInfo = false;
    }
  }

  async onActiveDomain() {
    try {
      if (!this.domain._id) {
        return this.$pushNotification.error("Not found DomainId");
      }
      this.loading = true;
      await this.$api.domain.verifyDomain(this.domain._id);
      this.$pushNotification.success("Verify domain successfully");
      this.dialogActiveDomain = false;
      this.onGetList();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async onGetSslInfo() {
    if (!this.domain._id) {
      return this.$pushNotification.error("Not found DomainId");
    }
    try {
      this.loadingInfo = true;
      const response = await this.$api.domain.getSslInfo(this.domain._id);
      if (response?.data?.dns) {
        this.sslInfo.push({
          type: "CName",
          cname_validation_p1: response.data.dns.cname_validation_p1,
          cname_validation_p2: response.data.dns.cname_validation_p2,
        });
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingInfo = false;
    }
  }

  async onEnableSsl() {
    if (!this.domain._id) {
      return this.$pushNotification.error("Not found DomainId");
    }
    try {
      this.isErrorSsl = false;
      this.loading = true;
      await this.$api.domain.verifySsl(this.domain._id);
      this.$pushNotification.success("Enable SSL successfully");
      this.dialogEnableSsl = false;
      this.onGetList();
    } catch (error) {
      this.isErrorSsl = true;
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async onDeleteDomain() {
    try {
      if (!this.domain._id) {
        return this.$pushNotification.error("Not found domainId");
      }
      this.loading = true;
      await this.$api.domain.delete(this.domain._id);
      this.dialogRemoveDomain = false;
      this.$pushNotification.success("Delete domain successfully");
      this.onGetList();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async onChangeStatus(domain: IResponseDomain) {
    try {
      const body = {
        domainId: domain._id,
        enabled: domain.enabled,
        isVerifiedMail: domain.isVerifiedMail,
        supportEmail: domain.supportEmail,
      };
      await this.$api.domain.update(body);
      this.$pushNotification.success("Change status successfully");
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }
  loadingExport = false;
  downloadFile() {
    this.loadingExport = true;
    let txtFile = parseTxtText(this.dataVerify);
    var FileSaver = require("file-saver");
    var blob = new Blob([`${txtFile}`], {
      type: "text/plain;charset=utf-8",
    });
    FileSaver.saveAs(blob, `${this.domain.domain}.txt`);
    this.loadingExport = false;
  }

  onRedirectPage() {
    this.config.page = this.page;
    this.onGetList();
  }

  onCopyText(text: string) {
    try {
      navigator.clipboard.writeText(text);
      this.onCopySuccess();
    } catch (error) {
      this.onCopyError();
    }
  }

  onCopySuccess() {
    this.$pushNotification.success("Copied successfully");
  }

  onCopyError() {
    this.$pushNotification.success("Copy failed");
  }

  @Watch("config.page")
  changedPage() {
    this.onGetList();
  }

  @Watch("dialogActiveDomain")
  changedDialogActiveDomain(value: boolean) {
    if (!value) {
      this.domainInfo = [];
    }
  }

  @Watch("dialogEnableSsl")
  changedDialogEnableSsl(value: boolean) {
    if (!value) {
      this.sslInfo = [];
      this.isErrorSsl = false;
    }
  }

  @Watch("dialogVerifyEmail")
  changedDialogVerifyEmail(value: boolean) {
    if (!value) {
      this.dataVerify = {};
    }
  }
}
</script>

<style></style>
